package service

import (
	"net/http"

	"github.com/gin-gonic/gin"

	"demo/internal/biz"
)

// GreeterService is a greeter service.
type GreeterService struct {
	uc *biz.GreeterUsecase
}

// NewGreeterService new a greeter service.
func NewGreeterService(uc *biz.GreeterUsecase) *GreeterService {
	return &GreeterService{uc: uc}
}

// SayHello implements helloworld.GreeterServer.
func (s *GreeterService) SayHello(ctx *gin.Context) {
	name := ctx.Param("name")
	g, err := s.uc.CreateGreeter(ctx, &biz.Greeter{Hello: name})
	if err != nil {
		return
	}
	ctx.AbortWithStatusJSON(http.StatusOK, gin.H{
		"message": g.Hello,
	})
	return
}
